/* Modulo de rvores binrias (com chaves inteiras)  */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "BinTree.h"



// cria uma rvore vazia
Tree CreateTree(void)
{
  return NULL;
}

// testa se a rvore  vazia 
int TreeEmpty(Tree root)
{
  return (root==NULL);
}

// conta o nmero de nodos da rvore
int TreeSize(Tree root)
{
  if (root==NULL)
    return 0;
  else return (1+TreeSize(root->left)+TreeSize(root->right));
}




// travessias
void Preorder(Tree root,void (*fun)(TreeEntry))
{
  if (!root)   //vazia 
    return;
  else { 
    fun(root->entry);
    Preorder(root->left,fun);
    Preorder(root->right,fun);
  }
}


void Inorder(Tree root,void (*fun)(TreeEntry))
{
  if (!root)   //vazia 
    return;
  else { 
    Inorder(root->left,fun);
    fun(root->entry);
    Inorder(root->right,fun);
  }
}


void Postorder(Tree root,void (*fun)(TreeEntry))
{
  if (!root)   //vazia 
    return;
  else { 
    Postorder(root->left,fun);
    Postorder(root->right,fun);
    fun(root->entry);
  }
}



// procedimento que cria uma cpia da rvore binria
void CopyTree(Tree from,Tree *to)     //  TreeNode  **to
{
  TreeNode *p;                       // Tree p;

  if (!from)  //vazia
    *to=NULL;
  else {
    p=(TreeNode*)malloc(sizeof(TreeNode));
    p->entry=from->entry;
    CopyTree(from->left,&(p->left)); 
    CopyTree(from->right,&(p->right));
    *to=p;
  }
}


// funo que cria uma cpia da rvore binria
Tree TreeCopy(Tree root)
{
  TreeNode *p;

  if (root) {
    p=(TreeNode*)malloc(sizeof(TreeNode));
    p->entry=root->entry;
    p->left=TreeCopy(root->left);
    p->right=TreeCopy(root->right);
    return p;
  }
  else return NULL;
}






// apaga toda rvore
void ClearTree(Tree *root)
{
  if (*root)   // No vazia
    {
      ClearTree(&((*root)->left));
      ClearTree(&((*root)->right));
      free(*root);
      *root=NULL;
    }
}

  











// insere um novo elemento numa rvore binria de procura.
Tree InsertTree(Tree root, KeyType k, char x[])
{
  if (!root){
    root=(Tree)malloc(sizeof(TreeNode));
    root->entry.key = k;
    strcpy(root->entry.name, x);
    root->left=root->right = NULL;
  } else if ( k < root->entry.key)
    root->left = InsertTree(root->left, k, x);
  else
    root->right = InsertTree(root->right, k, x);
  return root;
}
