/* Modulo de rvores binrias (com chaves inteiras)  */

#define  MAX  21

typedef int KeyType;     

typedef struct treeentry{
  KeyType key;
  char    name[MAX];
} TreeEntry;  
   

typedef struct treenode{
  TreeEntry entry;
  struct treenode *left;
  struct treenode *right;
} TreeNode;


typedef TreeNode *Tree;


// cria uma rvore vazia
Tree CreateTree(void);

// testa se a rvore  vazia 
int TreeEmpty(Tree);

// conta o nmero de nodos da rvore
int TreeSize(Tree);

// calcula a altura da rvore
int TreeHeight(Tree);

// apaga toda rvore
void ClearTree(Tree *);


// travessias
void Preorder(Tree,void (*fun)(TreeEntry));
void Inorder(Tree,void (*fun)(TreeEntry));
void Postorder(Tree,void (*fun)(TreeEntry));


// testa se a rvore binria est completa
int TreeComplete(Tree);  

// procedimento que cria uma cpia da rvore binria
void CopyTree(Tree,Tree *); 

// funo que cria uma cpia da rvore binria
Tree TreeCopy(Tree);



// RVORES BINRIAS DE PROCURA

// insere um novo elemento numa rvore binria de procura.
Tree InsertTree(Tree, KeyType, char *);



// procura um elemento numa rvore binria de procura (RECURSIVA)
TreeNode *TreeSearch(Tree, KeyType);

// procura um elemento numa rvore binria de procura (ITERATIVA)
TreeNode *TreeSearchIT(Tree, KeyType);


// remove um elemento (com uma dada chave) de uma rvore binria de procura.
void DeleteKeyTree(Tree *, KeyType);

// remove o nodo que est na raiz de uma rvore binria de procura.
void DeleteNodeTree(Tree *);


// actualiza a informao associada a uma chave numa rvore binria de procura.
Tree ChangeTree(Tree, KeyType, char *);

